import torch
from torch_geometric.nn import JumpingKnowledge


def test_jumping_knowledge():
    num_nodes, channels, num_layers = 100, 17, 5
    xs = list([torch.randn(num_nodes, channels) for _ in range(num_layers)])

    model = JumpingKnowledge('cat')
    assert model.__repr__() == 'JumpingKnowledge(cat)'
    assert model(xs).size() == (num_nodes, channels * num_layers)

    model = JumpingKnowledge('max')
    assert model.__repr__() == 'JumpingKnowledge(max)'
    assert model(xs).size() == (num_nodes, channels)

    model = JumpingKnowledge('lstm', channels, num_layers)
    assert model.__repr__() == 'JumpingKnowledge(lstm)'
    assert model(xs).size() == (num_nodes, channels)
